from _typeshed import Incomplete
from pyvqnet.backends import check_not_default_backend as check_not_default_backend, get_backend as get_backend
from pyvqnet.optim.optimizer import Optimizer as Optimizer
from pyvqnet.tensor import kfloat32 as kfloat32

vqnet_core: Incomplete

class RMSProp(Optimizer):
    """
    https://towardsdatascience.com/understanding-rmsprop-faster-neural-network-learning-62e116fcf29a?gi=94196933b149


    :param params: params of model which need to be optimized
    :param lr: learning_rate of model (default: 0.01)
    :param beta: coefficients used for computing running averages of gradient and
     its square (default: 0.99)
    :param epsilon: term added to the denominator to improve numerical stability (default: 1e-8)
    :return: a RMSProp optimizer

    Example::

        from pyvqnet.optim import rmsprop
        import numpy as np
        from pyvqnet.tensor import QTensor
        w = np.arange(24).reshape(1,2,3,4).astype(np.float64)
        param = QTensor(w)
        param.grad = QTensor(np.arange(24).reshape(1,2,3,4).astype(np.float64))
        params = [param]
        opti = rmsprop.RMSProp(params)

        for i in range(1,3):
            opti.step()

    """
    t: int
    epsilon: Incomplete
    beta: Incomplete
    def __init__(self, params, lr: float = 0.01, beta: float = 0.99, epsilon: float = 1e-08) -> None: ...
    def update_params(self) -> None: ...
